#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>
#include <pwd.h>
#include <grp.h>


int Busca (char*, char*);
void Presenta (char*);
int Concuerda (char*, char*);
void Largo (char *);
void Largonormal(char*);

char *ruta= "/home/labs/ord1/ord1x17";
char largo=0;char modo=0;
char *termino=NULL;
int auxiliar=0;
enum modo{ARCHIVO,USUARIO};


void main(int argc, char *argv[])
{
int a,i=1;
int falla;
char *ayuda = "Uso: busca [-d <directorio>] [-l]  [-f | -u] patron\n";
falla=0;

if (argc<2) falla=1;
while(i<argc)
{
   if(argv[i][0]=='-')
   {
      switch ((char)argv[i][1])
      {
      	case 'd':
           if ((i+1)==argc) {falla=1;break;}
           i++;
           ruta=argv[i];
           break;
        case 'l':
           largo=1;
           break;
        case 'f':
            modo=ARCHIVO;
            if ((i+1)==argc) {falla=1;break;}
            i++;
            termino=argv[i];
            break;
        case 'u':
            modo=USUARIO;
            if ((i+1)==argc) {falla=1;break;}
            i++;
            termino=argv[i];
            break;
        default:
           falla=1;
           break;   
      }
   }
else {termino=argv[i];} 
i++;
}
if(termino==NULL) falla=1; 

if (falla)
   {
   fprintf(stderr,ayuda);
   exit(1);
   }
Busca (ruta, termino);
}




void Presenta(char *archivo)
{
printf("\n%s\n", archivo);
Largonormal(archivo);
if (largo==1) Largo(archivo);
}

/***********************
Presentainode
presenta los inodes a  que esta enlazado
************************/

void Presentainode(char *archivo)
{
printf("\n    Enlazado a: %s\n", archivo);
Largonormal(archivo);
}


void Largonormal(char* archivo)
{
struct stat buf;
long inode;
int i;
char permiso [] = {'x', 'w', 'r'};
if (stat(archivo,&buf)==-1)
	{perror(archivo);exit (-1);}

printf("Longitud: %d bytes.\n", buf.st_size);
printf("Permisos: ");
for (i=0;i<=9;i++)
	{
	if (buf.st_mode & (0400 >> i))
	printf("%c",permiso[(8-i)%3]);
	else printf("-");
	}	
printf("\n");

}


void Largo(char* archivo)
{
struct stat buf;
struct passwd *pw;
struct group *gr;
int i;
char permiso [] = {'x', 'w', 'r'};
if (stat(archivo,&buf)==-1)
	{perror(archivo);exit (-1);}
printf("Numero de nodo-i: %d\n",buf.st_ino);
printf("Tipo: ");
switch (buf.st_mode & S_IFMT)
	{
	case S_IFREG:
		printf("ordinario.\n");break;
	case S_IFDIR:
		printf("directorio.\n");break;
	case S_IFCHR:
		printf("especial. (modo caracter)\n");break;
	case S_IFBLK:
		printf("especial. (modo bloque)\n");break;
	case S_IFIFO:
		printf("tuberia.\n");break;
	}
printf("Enlaces: %d\n",buf.st_nlink);

printf("Usuario: ");
if ((pw=getpwuid(buf.st_uid))==NULL) printf("Desconocido.\n");
	else printf("%s.\n", pw->pw_name);

printf("Grupo: ");
if ((gr=getgrgid(buf.st_gid))==NULL) printf("Desconocido.\n");
	else printf("%s.\n", gr->gr_name);

printf("Ultimo acceso: %s", asctime (localtime (&buf.st_atime)));
printf("Ultima modificacion: %s", asctime(localtime(&buf.st_mtime)));
printf("Ultimo cambio de estado: %s", asctime(localtime(&buf.st_ctime)));

}


	
