#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <string.h>



void Presentainode(char *archivo);
int Buscainode (char *, long,char *);
int Concuerda (char*, char*);


/***********************
Buscainode
Busca elementos que tengan ese inode
Y rechaza el nombre que le pasas. (Para que no se repita);
************************/
int Buscainode (char *ruta, long elemento, char *rechaza)
{
DIR *dirp;
struct dirent *dp;
struct stat buf;
int ok, i;
char archivo[256], tipo;

if ((dirp = opendir(ruta)) == NULL)
	{
	perror(ruta);
	return -1;
	}
while ((dp=readdir(dirp)) != NULL)
	{
	sprintf (archivo, "%s/%s",ruta, dp->d_name);
	ok= stat (archivo,&buf);
	if ((ok != -1) && (buf.st_mode & S_IFMT) == S_IFDIR)
		{

		if (Concuerda (dp->d_name,".")) continue;
		if (Concuerda (dp->d_name,"..")) continue;
		if (Concuerda (dp->d_name,rechaza)) continue; /*ATENCION CON ESTE CONCUERDA*/
                if (buf.st_ino==elemento)
			Presentainode(archivo);
        		Buscainode(archivo,elemento,rechaza);
		}
	else if (ok!=-1)
		{
		if (Concuerda (dp->d_name,rechaza)) continue; /*ATENCION CON ESTE CONCUERDA*/
		if (buf.st_ino==elemento)
			Presentainode(archivo);  /*Antes sin inode*/
		}
	else if (ok!=-1) printf ("Hubo algun error al abrir directorio");
	}
closedir(dirp);

}

/*****************************
Busca
Buscara el elemento en la ruta que le pases
*******************************/

int Busca (char *ruta,char *elemento)
{
DIR *dirp;
struct dirent *dp;
struct stat buf;
int ok, i;
char archivo[256], tipo;
char oldarchivo[256];
if ((dirp = opendir(ruta)) == NULL)
	{
	perror(ruta);
	return -1;
	}
while ((dp=readdir(dirp)) != NULL)
	{
        /*printf("ruta: %s--",ruta);*/
	sprintf (archivo, "%s/%s",ruta, dp->d_name);
        ok= stat (archivo,&buf); 
	
        if ((ok != -1) && (buf.st_mode & S_IFMT) == S_IFDIR)
		{

		if (Concuerda (dp->d_name,".")) continue;
		if (Concuerda (dp->d_name,"..")) continue;
		if (Concuerda(dp->d_name,elemento))
			Presenta(archivo);
		strcpy (oldarchivo,archivo);
                Busca(archivo,elemento);
                }
	else if (ok!=-1)
		{
		if (Concuerda(dp->d_name,elemento))
			{
                        Presenta(archivo);
                       /* printf("Ahora viene el cotarro\n");*/
                       /* printf("oldarchivo es: %s %d\n",oldarchivo,buf.st_ino);*/

                        Buscainode(ruta,buf.st_ino,dp->d_name); /*COTARRO*/
                        }
		
                }
	else if (ok!=-1) printf ("Hubo algun error al abrir directorio");
	}
closedir(dirp);
}

int Concuerda (char *a,char *b)
{
if (strcmp(a,b)) return 0;
else return 1;
}



